<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Http\Controllers\V1;

use Jiannei\Response\Laravel\Support\Facades\Response;
use Jiannei\Response\Laravel\Support\Traits\ExceptionTrait;
use Laravel\Lumen\Routing\Controller as BaseController;

abstract class Controller extends BaseController
{
    use ExceptionTrait;


    /**
     * request 参数验证
     * @param $request
     * @param $message
     * @return bool|\Illuminate\Http\JsonResponse
     */
    protected function validateRequest($request, $message){

        $validateArr = [];
        collect($message)->map(function($value,$key) use (&$validateArr){
            $keys = explode('.',$key);
            $validateArr[$keys[0]] = $keys[1];
        });

        $validator = Validator($request->all(), $validateArr, $message);

        if ($validator->fails()) {
            foreach($validator->errors()->getMessages() as $error) {
                return Response::fail($error[0]);
            }
        }
        return true;
    }
}
