<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Providers;

use App\Repositories\Enums\PermissionEnum;
use Illuminate\Support\Facades\Gate;
use Illuminate\Support\ServiceProvider;
use App\Providers\Auth\AdminUsersProvider;

class AuthServiceProvider extends ServiceProvider
{
    /**
     * Boot the authentication services for the application.
     */
    public function boot()
    {
        //Gate::before(PermissionEnum::gateBeforeCallback());
        $this->app['auth']->provider('superadmin', function ($app, array $config) {
            return new AdminUsersProvider($app, $config['model']);
        });
    }
}
