<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Providers;

use App\Repositories\Eloquent\BaseRepository;
use Prettus\Repository\Contracts\RepositoryInterface;
use Prettus\Repository\Providers\LumenRepositoryServiceProvider;

class RepositoryServiceProvider extends LumenRepositoryServiceProvider
{

    protected $bindsClass =
        [
            'App\Repositories\Contracts\UsersRepository'          => 'App\Repositories\Eloquent\UsersRepositoryEloquent',
            'App\Repositories\Contracts\MenusRepository'          => 'App\Repositories\Eloquent\MenusRepositoryEloquent',
            'App\Repositories\Contracts\RolesRepository'          => 'App\Repositories\Eloquent\RolesRepositoryEloquent',
            'App\Repositories\Contracts\BhPordersRepository'      => 'App\Repositories\Eloquent\BhPordersRepositoryEloquent',
            'App\Repositories\Contracts\BhSordersRepository'      => 'App\Repositories\Eloquent\BhSordersRepositoryEloquent',
            'App\Repositories\Contracts\BhSoitemsRepository'      => 'App\Repositories\Eloquent\BhSoitemsRepositoryEloquent',
            'App\Repositories\Contracts\BhSorderRefundRepository' => 'App\Repositories\Eloquent\BhSorderRefundRepositoryEloquent',
            'App\Repositories\Contracts\ToolsTaskRepository'      => 'App\Repositories\Eloquent\ToolsTaskRepositoryEloquent',
        ];

    /**
     * Bootstrap services.
     */
    public function boot()
    {
        $this->bindRepository();
    }

    protected function bindRepository()
    {
        if(empty($this->bindsClass)){
            return ;
        }

        foreach($this->bindsClass as $class => $concrete){
            $this->app->bind($class,$concrete);
        }

    }
}
