<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Repositories\Criteria;

use Illuminate\Database\Eloquent\Builder;
use App\Repositories\Criteria\Criteria; 

class UserCriteria extends Criteria
{
    protected function condition(Builder $query): void
    {
        if ($name = $this->request->get('nickname')) {
            $query->where('nickname', '=', $name);
        }

        if ($email = $this->request->get('email')) {
            $query->where('email', 'like', "%$email%");
        }

        if ($username = $this->request->get('username')) {
            $query->where('username', '=', $username);
        }
    }
}
