<?php

/*
 * This file is part of the Jiannei/lumen-api-starter.
 *
 * (c) Jiannei <longjian.huang@foxmail.com>
 *
 * This source file is subject to the MIT license that is bundled
 * with this source code in the file LICENSE.
 */

namespace App\Repositories\Models;

class BhPorders extends Model
{

    protected $table = 'porders';

    protected $connection = 'bh_mysql';

    protected $primaryKey = 'po_id';

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'po_sup_order','po_if_direct'
    ];

    protected $guarded = ['updated_at'];

    /**
     * The attributes excluded from the model's JSON form.
     *
     * @var array
     */
    protected $hidden = [

    ];

    /**
     * update时不做自动更新时间操作
     * @return null
     */
    public function getUpdatedAtColumn()
    {
        return null;
    }
}
