<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;

class CreateToolsTaskTable extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        $tableNames = 'tools_task';

        Schema::create($tableNames, function (Blueprint $table) {
            $table->id();
            $table->string('name')->comment('任务名称');
            $table->longText('exec_content')->comment('任务内容');
            $table->enum('status',['notexec','running','error','finish'])->comment('任务状态');
            $table->string('type')->comment('任务类型');
            $table->longText('error_message')->nullable()->comment('错误信息');
            $table->unsignedTinyInteger('create_by')->comment('创建人');
            $table->unsignedTinyInteger('exec_nums')->default(0)->comment('执行次数');

            $table->timestamps();
        });
        Schema::table($tableNames,function(Blueprint $table){
            DB::statement('ALTER TABLE '.$table->getTable(). ' ROW_FORMAT=DYNAMIC;');
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('tools_task');
    }
}
