<?php

use Database\Factories\PostFactory;
use Illuminate\Database\Seeder;

use App\Support\Traits\Helpers;
use App\Repositories\Models\AdminUsers;
use Illuminate\Support\Facades\DB;

class AdminUsersSeeder extends Seeder
{
    use Helpers;

    protected $userList = [
        [
            'username' =>'admin',
            'nickname' =>'admin',
            'password' => 'admin123456',
            'email' => 'admin@admin.com',
            'token' => '',
            'status' => 1,
            'is_admin' => 1,
            'lastlogin' => 0,
            'created_at' => '',
            'updated_at' => ''
        ]
    ];

    public function run()
    {
        //$this->command->getOutput()->info('正在初始化管理员数据中.');

        try{
            DB::beginTransaction();

            collect($this->userList)->map(function($user){

                $admin = app(AdminUsers::class);
                $user['password'] = $admin->encryptPassword($user['password']);
                $user['token'] = $this->randomFromDevice(16);
                $user['created_at'] = date('Y-m-d H:i:s',time());
                $user['updated_at'] = date('Y-m-d H:i:s',time());

                AdminUsers::insert([$user]);

            });

            DB::commit();

            $this->command->getOutput()->info('初始化管理员数据成功.');

        }catch(Exception $e){
            $this->command->getOutput()->error('初始化管理员失败，原因：'.$e->getMessage());
            DB::rollback();
        }

    }
}
