<?php

use Illuminate\Database\Seeder;

use App\Repositories\Models\Menus;
use Illuminate\Support\Facades\DB;
use Spatie\Permission\Models\Role;

class RolesSeeder extends Seeder
{

    protected $rolesList = [
        [
            'name' => 'admin',
            'is_default' => 0,
            'remark' => '超级管理员组，拥有最高权限',
            'guard_name' => '',
            'created_at' => '',
            'updated_at' => ''
        ],
    ];

    public function run()
    {
        //$this->command->getOutput()->info('正在初始化角色数据中.');

        try{
            DB::beginTransaction();

            collect($this->rolesList)->map(function($role){

                $role['guard_name'] = config('auth.defaults.guard');
                $role['created_at'] = date('Y-m-d H:i:s',time());
                $role['updated_at'] = date('Y-m-d H:i:s',time());

                Role::create($role,$role['guard_name']);

            });

            DB::commit();

            $this->command->getOutput()->info('初始化角色数据成功.');

        }catch(Exception $e){
            $this->command->getOutput()->error('初始化角色失败，原因：'.$e->getMessage());
            DB::rollback();
        }

    }
}
