<?php

/*
|--------------------------------------------------------------------------
| Application Routes
|--------------------------------------------------------------------------
|
| Here is where you can register all of the routes for an application.
| It is a breeze. Simply tell Lumen the URIs it should respond to
| and give it the Closure to call when that URI is requested.
|
 */

$api->version('v1', function($api) {

    $api->group(['namespace'=>'App\Http\Controllers\V1','middleware' => ['api.auth','permissions'], 'providers' => 'jwt'], function($api) {

        //菜单相关
        $api->get('/adminapi/permission/menu/userRoleMenuList', ['uses'=>'PermissionsController@getUserRoleMenuList']);
        $api->post('/adminapi/permission/menu/edit', ['permission' => 'menu.permission.edit', 'uses'=>'PermissionsController@editMenus']);
        $api->post('/adminapi/permission/menu/subAdd', ['permission' => 'menu.permission.add', 'uses'=>'PermissionsController@addSubMenus']);
        $api->post('/adminapi/permission/menu/del', ['permission' => 'menu.permission.del','uses'=>'PermissionsController@deleteMenus']);
        $api->get('/adminapi/permission/menu/all', ['permission' => 'menu.permission.list', 'uses'=>'PermissionsController@getAllMenuList']);

        //角色相关
        $api->get('/adminapi/permission/role/getAllByPage', ['permission' => 'role.permission.list.*', 'uses'=>'PermissionsController@getAllByPage']);
        $api->get('/adminapi/permission/role/getAllList', ['permission' => 'role.permission.list.view', 'uses'=>'PermissionsController@getAllList']);
        $api->post('/adminapi/permission/role/add', ['permission' => 'role.permission.add', 'uses'=>'PermissionsController@addRole']);
        $api->post('/adminapi/permission/role/edit', ['permission' => 'role.permission.edit', 'uses'=>'PermissionsController@editRole']);
        $api->post('/adminapi/permission/role/delByIds', ['permission' => 'role.permission.del', 'uses'=>'PermissionsController@delByIds']);
        $api->post('/adminapi/permission/role/editRolePermission', ['permission' => 'role.permission.edit', 'uses'=>'PermissionsController@editRolePermission']);
        $api->post('/adminapi/permission/role/setDefault', ['permission' => 'role.permission.edit', 'uses'=>'PermissionsController@editRoleDefault']);

        $api->get('/adminapi/permission/dictData/defaultButtonPermission', ['uses'=>'PermissionsController@getDefaultButtonPermission']);
    });

});

